use crate::{SortMessage, SortVisualizer};

pub fn sort(vis: &mut SortVisualizer) {
	let n = vis.arr.len();
	let low = 0;
	let high = n - 1;

	quick_sort(vis, low, high);

	vis.tx.send(SortMessage::Done).unwrap();
}

fn quick_sort(vis: &mut SortVisualizer, low: usize, high: usize) {
	if low < high {
		let pivot = partition(vis, low, high);
		if pivot > 0 {
			quick_sort(vis, low, pivot - 1);
		}
		quick_sort(vis, pivot + 1, high);
	}
}

fn partition(vis: &mut SortVisualizer, low: usize, high: usize) -> usize {
	let pivot = high;
	let mut i = low as isize - 1;

	for j in low..high {
		if vis.arr[j] < vis.arr[pivot] {
			i += 1;
			vis.arr.swap(i as usize, j);
			vis.tx.send(SortMessage::Data(vis.arr.clone())).unwrap();
		}
	}

	vis.arr.swap((i + 1) as usize, pivot);
	vis.tx.send(SortMessage::Data(vis.arr.clone())).unwrap();

	(i + 1) as usize
}
